#!/usr/local/bin/ruby


# 1. Include the library.

require "sajax"

# 2. Create a Sajax class object.

sajax= Sajax.new()

# 3. Define exported functions (called from JavaScript).

sajax.export("multiply") do |x, y|
  x.to_i * y.to_i
end

# 4. Call the request handler.

sajax.handle_client_request()

# 5. Setup your HTML (including the JavaScript the library generates).

print <<"EOS"
Content-Type: text/html

<html><head>
  <title>Multiplier</title>
  <script>
    
    // The library-generated script.
    #{sajax.javascript}
    
    function do_multiply_cb(z) {
      document.getElementById("z").value = z;
    }
    
    function do_multiply() {
      
      var x= document.getElementById("x").value;
      var y= document.getElementById("y").value;
      
      // Here the exported function 'multiply' is called.
      // The last argument is a call-back function which is called
      // with the return-value of 'multiply'.
      x_multiply(x, y, do_multiply_cb);
      
    }
    
  </script>
</head><body>

  <form>
    <input type="text" name="x" id="x" value="2" size="3">
    *
    <input type="text" name="y" id="y" value="3" size="3">
    =
    <input type="text" name="z" id="z" value="" size="3">
    <input type="button" name="check" value="Calculate"
           onclick="do_multiply(); return false;">
  </form>

</body></html>
EOS
